/*!
 * @file cr_engine.h
 * @brief The collision reaction engine, defining generic collision reactions to collision events
*/

#ifndef _CR_ENGINE_
#define _CR_ENGINE_

#include "base_object.h"

// FORWARD DECLARATION

//! A default singleton class.
class CREngine : public BaseObject {

 public:
  virtual ~CREngine(void);
  /** @returns a Pointer to the only object of this Class */
  inline static CREngine* getInstance(void) { if (!singletonRef) singletonRef = new CREngine();  return singletonRef; };


  void subscribeToCollisionEvent();

 private:
  CREngine(void);
  static CREngine* singletonRef;
};

#endif /* _CR_ENGINE_ */
